Bug 456337 - Review Request: NetBeans 6.1 - Integrated Development Environment (IDE)
Review Request: NetBeans 6.1 - Integrated Development Environment (IDE)
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
https://fedoraproject.org/wiki/Featur...
:
: 439265 (view as bug list)
Depends On: 456266 456273 456276 456280 456281 456298 456312 456316 456341
Blocks:
  Show dependency treegraph
 
Reported: 2008-07-22 18:54 EDT by Victor G. Vasilyev
Modified: 2008-09-19 06:23 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-09-09 21:29:00 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
langel: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Victor G. Vasilyev 2008-07-22 18:54:44 EDT
Spec URL: http://nbi.netbeans.org/files/documents/210/2057/netbeans.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2058/netbeans-6.1-1.fc10.src.rpm
Description: 
Integrated Development Environment (IDE) for Java, C/C++, Ruby, UML, etc.
Comment 1 Victor G. Vasilyev 2008-07-31 13:09:34 EDT
This is my first contribution so I need a sponsor please.
Comment 2 Lillian Angel 2008-08-05 12:24:35 EDT
*** Bug 439265 has been marked as a duplicate of this bug. ***
Comment 3 Victor G. Vasilyev 2008-09-03 13:38:53 EDT
The second is prepared for review.

Spec URL: http://nbi.netbeans.org/files/documents/210/2057/netbeans.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2164/netbeans-6.1-2.fc10.src.rpm

Changes:
- rpmlint warnings about hidden .noautoupdate files are suppressed
- Package dependencies are adjusted
- Relative links are used
- The alternatives system is used to run netbeans
- Group is changed
- nb_distro_id is added
- The %%{buildroot} is used everywhere instead of $RPM_BUILD_ROOT
- A version requirement for the xerces-j2 is decreased from 2.8.0 up to 2.7.1
- The warnings about links to external JARs are suppressed
- Redundant stub swing-worker-1.1.jar is removed
- The standard-nbm-license.txt is added to all subpackages
Comment 4 Lillian Angel 2008-09-05 14:18:37 EDT
Fails to build
$ rpmbuild --rebuild netbeans-6.1-2.fc10.src.rpm 
...
...

build-init:
[parseprojectxml] Distilling /notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/build/public-package-jars/org-netbeans-libs-ini4j.jar from [/notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/netbeans/ide9/modules/org-netbeans-libs-ini4j.jar, /notnfs/langel/rpm/BUILD/netbeans-6.1/libs.ini4j/external/ini4j-0.2.6.jar, /notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/netbeans/ide9/modules/ext/ini4j-0.2.6.jar]
[parseprojectxml] Classpath entry /notnfs/langel/rpm/BUILD/netbeans-6.1/libs.ini4j/external/ini4j-0.2.6.jar does not exist; skipping
[parseprojectxml] Classpath entry /notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/netbeans/ide9/modules/ext/ini4j-0.2.6.jar does not exist; skipping
  [nbmerge] Failed to build target: all-mercurial

BUILD FAILED
/notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/build.xml:707: The following error occurred while executing this line:
/notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/build.xml:702: The following error occurred while executing this line:
/notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/build.xml:752: The following error occurred while executing this line:
/notnfs/langel/rpm/BUILD/netbeans-6.1/nbbuild/templates/projectized.xml:87: java.util.zip.ZipException: ZIP file must have at least one entry

Total time: 47 seconds
error: Bad exit status from /var/tmp/rpm-tmp.37964 (%build)
Comment 5 Victor G. Vasilyev 2008-09-08 07:00:31 EDT
Lillian,

Such error is possible if the latest release (i.e. release 4) of the ini4j RPM isn't installed on your system, e.g 
ini4j-0.3.2-3.fc10.noarch.rpm is installed instead of 
ini4j-0.3.2-4.fc10.noarch.rpm

Because,

1. 
$ rpm -qp --requires netbeans-6.1-2.fc10.src.rpm
...
ini4j >= 0.2.6
...

2.
$ rpm -qpl ini4j-0.3.2-4.fc10.noarch.rpm
...
/usr/share/java/ini4j.jar
...

3. the %build script of the netbean.spec contains the command:
%{__ln_s} -f %{_javadir}/ini4j.jar  ${IDE_EXT_DIR}/ini4j-0.2.6.jar

Unfortunately, in contrast to the release 4, the release 3 doesn't define versionless link (i.e. ini4j.jar) to the ini4j-0.3.2.jar
Comment 6 Lillian Angel 2008-09-08 11:16:12 EDT
Where can I get ini4j-0.3.2-4 from? Is this the version that is going into rawhide?
Comment 7 Lillian Angel 2008-09-08 11:23:17 EDT
nevermind! found it. thanks
Comment 8 Victor G. Vasilyev 2008-09-08 11:46:02 EDT
It is a mystic issue, because the http://cvs.fedoraproject.org/viewvc/devel/ list doesn't contain ini4j module, but yum shows it and cvs update is also successfully completed for me.
Comment 9 Lillian Angel 2008-09-08 11:50:25 EDT
Issues installing:

$ sudo rpm -Uvh /notnfs/langel/rpm/RPMS/noarch/netbeans-6.1-2.fc9.noarch.rpm /notnfs/langel/rpm/RPMS/noarch/netbeans-apisupport1-6.1-2.fc9.noarch.rpm /notnfs/langel/rpm/RPMS/noarch/netbeans-ide9-6.1-2.fc9.noarch.rpm /notnfs/langel/rpm/RPMS/noarch/netbeans-java2-6.1-2.fc9.noarch.rpm
Preparing...                ########################################### [100%]
   1:netbeans-ide9          ########################################### [ 25%]
   2:netbeans-java2         ########################################### [ 50%]
ln: creating symbolic link `/usr/share/netbeans/java2/ant/ant/bin/antRun': No such file or directory
ln: creating symbolic link `/usr/share/netbeans/java2/ant/ant/etc': No such file or directory
   3:netbeans-apisupport1   ########################################### [ 75%]
   4:netbeans               ########################################### [100%]

================================================

RPMLINT:

$ rpmlint /notnfs/langel/rpm/RPMS/noarch/netbeans-6.1-2.fc9.noarch.rpm /notnfs/langel/rpm/RPMS/noarch/netbeans-apisupport1-6.1-2.fc9.noarch.rpm /notnfs/langel/rpm/RPMS/noarch/netbeans-ide9-6.1-2.fc9.noarch.rpm /notnfs/langel/rpm/RPMS/noarch/netbeans-java2-6.1-2.fc9.noarch.rpm
netbeans.noarch: W: dangerous-command-in-%post ln
netbeans-ide9.noarch: W: dangerous-command-in-%post ln
netbeans-java2.noarch: W: dangerous-command-in-%post ln

Can the file linking be moved to %build or %install? It is also possibly these
create files that end up being unowned by the package.

The rm calls are ok.

netbeans.noarch: W: dangerous-command-in-%preun rm
netbeans-apisupport1.noarch: W: dangerous-command-in-%preun rm
netbeans-ide9.noarch: W: dangerous-command-in-%preun rm
netbeans-java2.noarch: W: dangerous-command-in-%preun rm

These are ok:
netbeans-apisupport1.noarch: W: class-path-in-manifest /usr/share/netbeans/apisupport1/modules/org-netbeans-modules-apisupport-project.jar 
...

4 packages and 0 specfiles checked; 0 errors, 27 warnings.

=================================================


http://fedoraproject.org/wiki/Packaging/Guidelines

1 Packaging Guidelines

* 1.1 Naming
ok
* 1.2 Legal
ok
* 1.3 No inclusion of pre-built binaries or libraries
ok
* 1.4 Writing a package from scratch
ok
* 1.5 Modifying an existing package
ok
* 1.6 Filesystem Layout
n/a
XXXX 1.7 Use rpmlint
see above
* 1.8 Changelogs
ok
* 1.9 Tags
ok
* 1.10 BuildRoot tag
ok
* 1.11 Requires
ok
XXXX 1.12 BuildRequires
If the build requires 0.3.2-4, then please change the requirement from 0.2.6. This will cause problems for people who have manually installed ini4j from elsewhere and want to build netbeans themselves.
XXXX 1.13 Summary and description
If possible, add more to the descriptions. Also, put a line break between the description and the %package section
* 1.14 Encoding
ok
* 1.15 Documentation
ok
* 1.16 Compiler flags
ok
* 1.17 Debuginfo packages
n/a
* 1.18 Exclusion of Static Libraries
ok
* 1.19 Duplication of system libraries
ok
* 1.20 Beware of Rpath
ok
* 1.21 Configuration files
ok
* 1.22 Initscripts
ok
* 1.23 Desktop files
ok
* 1.24 Macros
ok
* 1.25 Handling Locale Files
ok
* 1.26 Timestamps
ok
* 1.27 Parallel make
ok
* 1.28 Scriptlets requirements
ok
* 1.29 Running scriptlets only in certain situations
ok
* 1.30 Scriplets are only allowed to write in certain directories
ok
* 1.31 Conditional dependencies
ok
* 1.32 Build packages with separate user accounts
ok
* 1.33 Relocatable packages
ok
* 1.34 Code Vs Content
ok
* 1.35 File and Directory Ownership
ok
* 1.36 Users and Groups
ok
* 1.37 Web Applications
ok
* 1.38 Conflicts
ok
* 1.39 No External Kernel Modules
ok
* 1.40 No Files or Directories under /srv
ok
* 1.41 Application Specific Guidelines
ok


http://fedoraproject.org/wiki/Packaging/ReviewGuidelines

MUST Items:

XXXX MUST: rpmlint must be run on every package. The output should be posted in the review.
See above
- MUST: The package must be named according to the Package Naming Guidelines .
ok
- MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines .
ok
- MUST: The package must meet the Packaging Guidelines .
ok
- MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
ok
- MUST: The License field in the package spec file must match the actual license.
ok
- MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
ok
- MUST: The spec file must be written in American English.
ok
- MUST: The spec file for the package MUST be legible. If the reviewer is unable to read the spec file, it will be impossible to perform a review. Fedora is not the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/).
ok
- MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
ok
- MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
ok
- MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. 
ok
- MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
ok
- MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
n/a
- MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
ok
- MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. Refer to the Guidelines for examples.
ok
- MUST: A package must not contain any duplicate files in the %files listing.
ok
- MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
ok
- MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ).
ok
- MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
ok
- MUST: The package must contain code, or permissable content. This is described in detail in the code vs. content section of Packaging Guidelines .
ok
- MUST: Large documentation files should go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity)
ok
- MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
- MUST: Header files must be in a -devel package.
ok
- MUST: Static libraries must be in a -static package.
n/a
- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
n/a
- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
n/a
- MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
ok
- MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
ok
- MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. 
ok
- MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
ok
- MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for details.
ok
- MUST: All filenames in rpm packages must be valid UTF-8.
ok


SHOULD Items:

- SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
ok
- SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
ok
- SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
ok
- SHOULD: The package should compile and build into binary rpms on all supported architectures.
ok
- SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
ok
- SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
ok
- SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
ok
- SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
ok
- SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. Please see File Dependencies in the Guidelines for further information. 
ok
Comment 10 Victor G. Vasilyev 2008-09-09 07:26:32 EDT
The next release is prepared for review.

Spec URL: http://nbi.netbeans.org/files/documents/210/2057/netbeans.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2174/netbeans-6.1-3.fc10.src.rpm

Changes (In reply to comment #9):
> Issues installing:
> ln: creating symbolic link `/usr/share/netbeans/java2/ant/ant/bin/antRun': No
> such file or directory
> ln: creating symbolic link `/usr/share/netbeans/java2/ant/ant/etc': No such
> file or directory
- The symlink locations for both java2/ant/ant/bin/antRun and java2/ant/ant/etc are corrected
> Can the file linking be moved to %build or %install? It is also possibly these
> create files that end up being unowned by the package.
>
> XXXX 1.7 Use rpmlint
> see above
- Linking to the external JARs is moved to the %%install script from the %%post

> XXXX 1.12 BuildRequires
> If the build requires 0.3.2-4, then please change the requirement from 0.2.6.
> This will cause problems for people who have manually installed ini4j from
> elsewhere and want to build netbeans themselves.
- The requires for a version of the ini4j package are corrected

> XXXX 1.13 Summary and description
> If possible, add more to the descriptions. Also, put a line break between the
> description and the %package section
- The %%description content for the NetBeans IDE is updated
>
> XXXX MUST: rpmlint must be run on every package. The output should be posted in
> the review.
> See above 

=== netbeans-6.1-3.fc10.src.rpm
0 errors, 0 warnings

=== netbeans-6.1-3.fc10.noarch.rpm
0 errors, 3 warnings, including:
- 2 "dangling-relative-symlink" for "external" components provided by the NetBeans platform (harness, platform8)
- 1 "dangerous-command-in-%preun rm" due to %rm_noautoupdate 

=== netbeans-apisupport1-6.1-3.fc10.noarch.rpm
0 errors, 2 warnings, including:
- 1 "dangerous-command-in-%preun rm"  due to %rm_noautoupdate 
- 1 "class-path-in-manifest"  

=== netbeans-ide9-6.1-3.fc10.noarch.rpm
0 errors, 30 warnings, including:
- 8 "dangling-symlink" and 8 "symlink-should-be-relative" for external JARs
- 1 "dangerous-command-in-%preun rm"  due to %rm_noautoupdate 
- 13 "class-path-in-manifest"

=== netbeans-java2-6.1-3.fc10.noarch.rpm
0 errors, 35 warnings, including:
- 14 "dangling-symlink" and 14 "symlink-should-be-relative" for external JARs
- 1 "dangerous-command-in-%preun rm"  due to %rm_noautoupdate 
- 6 "class-path-in-manifest"
Comment 11 Lillian Angel 2008-09-09 08:59:54 EDT
APPROVED.
Comment 12 Victor G. Vasilyev 2008-09-09 09:57:56 EDT
New Package CVS Request
=======================
Package Name: netbeans
Short Description: NetBeans IDE - Integrated Development Environment
Owners: victorv
Branches:
InitialCC:
Comment 13 Victor G. Vasilyev 2008-09-09 11:16:33 EDT
New release due to the koji build http://koji.fedoraproject.org/koji/taskinfo?taskID=815399 failed.

Spec URL: http://nbi.netbeans.org/files/documents/210/2057/netbeans.spec
SRPM URL: http://nbi.netbeans.org/files/documents/210/2175/netbeans-6.1-4.fc10.src.rpm

Changes:
- The java, java-devel and jpackage-utils requirenments are used

Successful scratch koji build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=815688
Comment 14 Kevin Fenzi 2008-09-09 19:46:02 EDT
cvs done.
Comment 15 Victor G. Vasilyev 2008-09-09 21:29:00 EDT
The koji build (dist-f10, devel:netbeans-6_1-4_fc10) completed successfully
http://koji.fedoraproject.org/koji/taskinfo?taskID=816839

Congratulation!

The feature https://fedoraproject.org/wiki/Features/NetBeans is completely imported into Fedora.
Comment 16 Milos Jakubicek 2008-09-16 09:08:38 EDT
Would you mind releasing an update for F8/F9?
Comment 17 Victor G. Vasilyev 2008-09-19 05:46:31 EDT
Hello Milos,

Our original plan considers only F10 as a target release for NetBeans. 
We need complete this plan before any next steps, including updates.

The NetBeans packages have been completely prepared on F9, so, I think, they will work properly on F9 if all *_fc10 packages, including required ones (see http://wiki.netbeans.org/Fedora10PackagingNBStatus ), will be installed from the rawhide repo on F9 platform via yum. However, I'm not sure about F8.

Milos, your comments/ideas/help in this area will be very much appreciated. You can use linux-packaging@installer.netbeans.org to discuss it.
Comment 18 Victor G. Vasilyev 2008-09-19 06:23:01 EDT
FYI http://wiki.netbeans.org/FedoraPackagingNBWishList

Note You need to log in before you can comment on or make changes to this bug.